; Enhanced Database example 
;by Siegfried Rings (CodeGuru)
;File$ = OpenFileRequester("PureBasic - Open", "C:\*.mdb", "Microsoft Access (*.mdb)|*.mdb;*.bat|Microsoft Excel (*.xls)|*.xls", 1)


;Copy the File (MDB) to c:\ !!

File$ = "C:\TestDB.mdb"

#ODBC_ADD_DSN = 1 ; Add Data source
#ODBC_CONFIG_DSN = 2 ; Configure (edit) Data source
#ODBC_REMOVE_DSN = 3 ; Remove Data source

#sqlChar = 1
#sqlMaxMsgLen = 512
#sqlFetchNext = 1
#sqlFetchFirst = 2
#sqlStillExecuting = 2
#sqlODBCCursors = 110
#sqlConcurrency = 7
#sqlCursorType = 6 
#BUFFERLEN = 256
#sqlColumnLabel = 18
#sqlNts = -3

; sql lock types
#sqlreadonly = 1
#sqllock = 2
#sqlrowver = 3
#sqlValues = 4

; sql cursor drivers
#sqluseifneeded = 0
#sqlUseODBC = 1
#sqlUseDriver = 2

; cursor types
#sqlforwardonly = 0
#sqlKeyset = 1
#sqldynamic = 2
#sqlStatic = 3

; sqlerror type
#sqlSuccess = 0
#sqlSuccessWithInfo = 1
#sqlerr = -1
#sqlNoDataFound = 100
#sqlClose = 0
#sqlDrop = 1
#sqlUnbind = 2
#sqlResetParams = 3


;makes a Connection 
Procedure MakeConnection(Driver.s,strAttributes.s)
Result=OpenLibrary(1,"ODBCCP32.DLL")
If Result 
 lpszDriver.s=Driver
 MyMemory=AllocateMemory(1,Len(strAttributes))
 CopyMemory(@strAttributes,MyMemory,Len(strAttributes))
 For L=1 To Len(strAttributes )
  If PeekB(MyMemory +l-1)=Asc(";"):PokeB(MyMemory +l-1,0):  EndIf
 Next L 
 Result = CallFunction(1, "SQLConfigDataSource", 0,#ODBC_ADD_DSN,lpszDriver.s,MyMemory ) 
 NewResult=SQLConfigDataSource_(0,#ODBC_ADD_DSN,lpszDriver.s,MyMemory ) 
 FreeMemory(1)
 CloseLibrary(1)
 If Result
  ProcedureReturn 1
 EndIf
EndIf
EndProcedure

;removes a connection
Procedure DeleteConnection(Driver.s,DSN.s)
Result=OpenLibrary(1,"ODBCCP32.DLL")
If Result 
 lpszDriver.s=Driver
 strAttributes.s = "DSN="+DSN
 Result = CallFunction(1, "SQLConfigDataSource", 0,#ODBC_REMOVE_DSN,lpszDriver.s,strAttributes ) 
 CloseLibrary(1)
 If Result
  ProcedureReturn 1;MessageRequester("Info","DSN Delete",0)
 EndIf
EndIf
EndProcedure

EXT.s=UCase(GetExtensionPart(File$))
Select EXT
 Case "MDB"
  Result=Makeconnection("Microsoft Access Driver (*.mdb)","Server=SomeServer; Description=Description For Purebasic MDB-ODBC;DSN=PureBasic_DSN;DBQ="+file$+";UID=Rings;PWD=Siggi;")
 Case "XLS"
  Result=Makeconnection("Microsoft Excel Driver (*.xls)","DSN=PureBasic_DSN;Description=Description For Purebasic Excel;FileType=Excel97;DBQ="+File$+";")
EndSelect

If InitDatabase() = 0
  MessageRequester("Error", "Can't initialize Database (ODBC v3 or better) environment", 0)
  End
EndIf

OpenConsole()
Dim DatabaseType.s(4)
DatabaseType(0) = "Unknown"
DatabaseType(1) = "Numeric"
DatabaseType(2) = "String"
DatabaseType(3) = "Float"

; First, let's see which drivers are attached to the system..
PrintN("Available drivers:")
PrintN("")
If ExamineDatabaseDrivers()
  While NextDatabaseDriver()
    PrintN(DatabaseDriverName()+" - "+DatabaseDriverDescription())
  Wend
EndIf

; Open an ODBC database
User$=""
Password$=""
#Database=1

Result = OpenDatabase(#Database, "PureBasic_DSN", User$, Password$) 
If Result
  Browse$="Select * from Authors" 
  PrintN("Result="+Str(Result))
  PrintN("Database successfully opened !")
  Repeat
  PrintN("---------------------------------------")
  PrintN("Type EXIT to quit.")
  PrintN("or anything else to browse database")

    Command$ = Input()
    Select UCase(Command$)
      Case "EXIT"
        Quit = 1
      Default

        If DatabaseQuery(Browse$)

          NbColumns = DatabaseColumns()
          PrintN("NbColums: " + Str(NbColumns))

          For k=0 To NbColumns-1
            PrintN(DatabaseColumnName(k) + " - " + DatabaseType(DatabaseColumnType(k)))
          Next

          PrintN("")
          Print ("Press return to continue") : Input()
          PrintN("")
          PrintN("Query Result -------------------------------------")

          While NextDatabaseRow()
            PrintN(GetDatabaseString(0)+Chr(9) +GetDatabaseString(1))
          Wend

          PrintN("--------------------------------------------------")
        Else
          PrintN("Bad Query !")
        EndIf
    EndSelect
  Until Quit = 1
Else
 MessageRequester("Info", "Operation canceled", 0)
EndIf

;and delete:
DeleteConnection("Microsoft Access Driver (*.mdb)","PureBasic_DSN") 
End
; ExecutableFormat=Console
; CursorPosition=6
; FirstLine=1
; Executable=C:\PureBasic\databasebrowser.exe
; DisableDebugger
; EOF
